//------------------------------------------------------------------------------
// <auto-generated>
//     This code was generated by a tool.
//     Runtime Version:4.0.30319.42000
//
//     Changes to this file may cause incorrect behavior and will be lost if
//     the code is regenerated.
// </auto-generated>
//------------------------------------------------------------------------------

namespace Tecan.Sila2.Cancellation
{
    
    
    /// <summary>
    /// This feature offers commands to cancel/terminate Commands. Cancellation is the act of stopping the running Command execution(s),
    /// irrevocably. The SiLA Server SHOULD be able to be in a state where any further
    /// commands can be issued after a cancellation.
    /// </summary>
    [Tecan.Sila2.SilaFeatureAttribute(false, "core.commands")]
    [Tecan.Sila2.SilaIdentifierAttribute("CancelController")]
    [Tecan.Sila2.SilaDisplayNameAttribute("Cancel Controller")]
    public partial interface ICancelController
    {
        
        /// <summary>
        /// Cancel a specified currently running Observable Command or cancel all currently running Commands (Observable and
        /// Unobservable).
        /// For any canceled Observable Command the SiLA Server MUST update the Command Execution Status to "Command Finished
        /// with Error".
        /// The SiLA Server MUST throw a descriptive error message indicating cancellation as the reason for the Command
        /// execution not being able to finish successfully for any canceled Command.
        /// </summary>
        /// <param name="commandExecutionUUID">The Command Execution UUID according to the SiLA Standard.</param>
        [Tecan.Sila2.ThrowsAttribute(typeof(InvalidCommandExecutionUUIDException))]
        [Tecan.Sila2.ThrowsAttribute(typeof(OperationNotSupportedException))]
        void CancelCommand([Tecan.Sila2.SilaDisplayNameAttribute("Command Execution UUID")] Uuid commandExecutionUUID);
        
        /// <summary>
        /// Cancels all currently running Observable and Unobservable Commands running on this SiLA Server.
        /// The SiLA Server MUST throw an Execution Error indicating 'cancellation' as the reason for the
        /// Command not being able to finish successfully.
        /// </summary>
        void CancelAll();
    }
    
    /// <summary>
    /// A Universally Unique Identifier (UUID) referring to observable command executions.
    /// </summary>
    [Tecan.Sila2.PatternConstraintAttribute("[0-9a-f]{8}\\-[0-9a-f]{4}\\-[0-9a-f]{4}\\-[0-9a-f]{4}\\-[0-9a-f]{12}")]
    public struct Uuid
    {
        
        private string _value;
        
        /// <summary>
        /// Initializes a new instance
        /// </summary>
        public Uuid(string value)
        {
            _value = value;
        }
        
        /// <summary>
        /// The inner value
        /// </summary>
        public string Value
        {
            get
            {
                return _value;
            }
        }
    }
    
    /// <summary>
    /// The given Command Execution UUID does not specify a command that is currently being executed.
    /// </summary>
    [Tecan.Sila2.SilaDisplayNameAttribute("Invalid Command Execution UUID")]
    public class InvalidCommandExecutionUUIDException : System.Exception
    {
        
        /// <summary>
        /// Create a new instance
        /// </summary>
        /// <param name="message">The actual error message</param>
        public InvalidCommandExecutionUUIDException(string message) : 
                base(message)
        {
        }
    }
    
    /// <summary>
    /// Canceling is not supported for the SiLA 2 Command with the
    /// specified CommandExecutionUUID.
    /// </summary>
    public class OperationNotSupportedException : System.Exception
    {
        
        /// <summary>
        /// Create a new instance
        /// </summary>
        /// <param name="message">The actual error message</param>
        public OperationNotSupportedException(string message) : 
                base(message)
        {
        }
    }
}
